from datetime import datetime, timedelta
import time

log_filename = '/var/log/futurehome/zipgateway/current'

bye_bye_log = ''
single_node_probed = ''
all_nodes_probed = ''

def iterate_over_file():
    with open(log_filename, 'r') as input:
        for line in input:
            if 'Bye bye' in line:
                bye_bye = line.split(" ")[1].split("\x1b[0m\x1b[32;1m")[1].split(".")[0].split("T")
                global bye_bye_log
                bye_bye_log = datetime.strptime(bye_bye[0] + " " + bye_bye[1], '%Y-%m-%d %H:%M:%S')
            if 'All nodes have been probed' in line:
                probed_time = line.split(" ")[1].split("\x1b[0m\x1b[32;1m")[1].split(".")[0].split("T")
                global all_nodes_probed
                all_nodes_probed = datetime.strptime(probed_time[0] + " " + probed_time[1], '%Y-%m-%d %H:%M:%S')
            if 'Probe of node' in line:
                probed_time = line.split(" ")[1].split("\x1b[0m\x1b[32;1m")[1].split(".")[0].split("T")
                global single_node_probed
                single_node_probed = datetime.strptime(probed_time[0] + " " + probed_time[1], '%Y-%m-%d %H:%M:%S')

def check_logs():
    timeout = 0
    global bye_bye_log
    global all_nodes_probed
    global single_node_probed
    while timeout <= 60:
        iterate_over_file()

        if not bye_bye_log and not single_node_probed and not all_nodes_probed:
            # We can start the adapter freerly
            break
        elif not bye_bye_log and not single_node_probed and all_nodes_probed:
            # We can start the adapter freerly
            break
        elif not bye_bye_log and single_node_probed and not all_nodes_probed:
            # We have to wait because there has been single node probe but not the rest
            print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))
        elif not bye_bye_log and single_node_probed and all_nodes_probed:
            # There is last single probe and all nodes probed logs
            # We have to check which is last one
            if single_node_probed <= all_nodes_probed:
                # It's okay we can start the adapter
                break
            else:
                # We have to wait.
                print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))
        elif bye_bye_log and not single_node_probed and not all_nodes_probed:
            # We have to wait, probably it shall never come here
            print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))
        elif bye_bye_log and not single_node_probed and all_nodes_probed:
            # Check which was first
            if bye_bye_log <= all_nodes_probed:
                # We can start the adapter
                break
            else:
                # We have to wait, that one probbaly will never happen but still.
                print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))
        elif bye_bye_log and single_node_probed and not all_nodes_probed:
            # This one might be pretty accurate, it means Zipgateway has just started
            if bye_bye_log <= single_node_probed:
                # We wait here for all nodes probed
                print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))
            else:
                # It means, Zipgateway is dead
                print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))
        elif bye_bye_log and single_node_probed and all_nodes_probed:
            # Typical situation when there were some starts/stops in near past.
            if bye_bye_log <= single_node_probed and single_node_probed <= all_nodes_probed:
                # We can start the adapter
                break
            else:
                # We want to wait.
                print("Waiting for zipgateway to probe all nodes, timeout: " + str(timeout))

        print("Zipgw last shutdown time: " + str(bye_bye_log))
        print("Zipgw last single node probed time: " + str(single_node_probed))
        print("Zipgw last all nodes probed time: " + str(all_nodes_probed))
        timeout += 5
        time.sleep(5)

check_logs()
