import socket
import binascii
import argparse
import random
import time
import threading

# addressing information of target
IPADDR = 'fd00:bbbb::0015'
PORTNUM = 4123


# enter the data content of the UDP packet as hex
# 0x23 0x02 0x80 0xd0 0x26 0x00 0x00 0x05 0x84 0x02 0x00 0x00 0x25 0x01 0xff 
# 0x23 0x02 0x80 0xd0 0xab 0x00 0x00 0x05 0x84 0x02 0x00 0x00 0x25 0x01 0xff 
# PACKETDATA = '230280d0ab00000584020000250100'.decode('hex')
# initialize a socket, think of it as a cable
# SOCK_DGRAM specifies that this is UDP
# s = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM, 0)
# connect the socket, think of it as connecting the cable to the address location
# s.connect((IPADDR, PORTNUM))
# send the command
# s.send(PACKETDATA)
# close the socket
# s.close()

def send_command(node_id, packet):
    ipaddr = 'fd00:bbbb::00%x' % node_id
    print(ipaddr)
    # SOCK_DGRAM specifies that this is UDP
    s = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM, 0)
    # connect the socket, think of it as connecting the cable to the address location
    s.connect((ipaddr, PORTNUM))
    # send the command  
    s.send(packet)
    # close the socket
    s.close()


def send_netman_command(packet):
    ipaddr = 'fd00:aaaa::3'
    # SOCK_DGRAM specifies that this is UDP
    s = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM, 0)
    s.bind(('', 4124))
    # connect the socket, think of it as connecting the cable to the address location
    s.connect((ipaddr, PORTNUM))
    # send the command  
    s.send(packet)
    # close the socket
    t1 = threading.Thread(target=receive_ima, args=(s,))
    t1.daemon = True
    t1.start()
    return s
    # s.close()
    # 2302 8050 a400 004d 0827 01


def out_bin_switch_set(addr, state, secure):
    if secure:
        # 0x23 0x02 0x80 0x50 0xfd 0x00 0x00 0x25 0x01 0xff
        packet = binascii.unhexlify('23028050fd00002501' + state)
    else:
        packet = binascii.unhexlify('230280d0ab000005840200002501' + state)
    send_command(addr, packet)


def out_bin_switch_get(addr, secure):
    if secure:
        # 0x23 0x02 0x80 0x50 0xfd 0x00 0x00 0x25 0x01 0xff
        packet = binascii.unhexlify('23028050fd00002502')
    else:
        packet = binascii.unhexlify('230280d0ab000005840200002502')
    send_command(addr, packet)


def request_ima(addr):
    # #define COMMAND_CLASS_NETWORK_MANAGEMENT_INSTALLATION_MAINTENANCE 0x67
    # PRIORITY_ROUTE_SET:
    # PRIORITY_ROUTE_GET
    # STATISTICS_GET: 0x04
    # CC_InstallationAndMaintenance.c 
    print("Requesting IMA")
    packet = binascii.unhexlify('23028050a400006704' + addr)
    send_netman_command(packet)


def receive_ima(sock):
    while True:
        print('\nwaiting to receive message')
        data, address = sock.recvfrom(4096)

        print('received {} bytes from {}'.format(
            len(data), address))
        print(binascii.hexlify(data))


if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument("cmd")
    parser.add_argument("iter_count")
    args = parser.parse_args()
    if args.cmd == "get-ima":
        request_ima('05')
        while 1:
            time.sleep(1)
    elif args.cmd == "send":
        iter_count = int(args.iter_count)
        for i in range(iter_count):
            print(i)
            out_bin_switch_set(2, 'ff', False)
            out_bin_switch_get(2, False)
            out_bin_switch_set(6, 'ff', True)
            out_bin_switch_get(6, True)
            out_bin_switch_set(7, 'ff', False)
            out_bin_switch_get(7, False)
            out_bin_switch_get(8, True)
            time.sleep(random.random() / 10)
